; Digital Dice Version 1.0 for TSE
; By Robin Kay
;

; You may not distribute a modified version of this program. However, you
; may take code from or base your program on this code providing that the
; resulting program is at least 50% of your own work.

.nolist
#include "tse.inc"
.list
.org    usermem-3
.db     $bb,$6d
 ret

.db "TSE",1              ; header
prgtitle:
.db " Digital Dice", 0   ; title
.dw 50                  ; stack required

init:

 ; Init vars
 ld hl, (2*256)+1
 ld (number), hl ; and (outof) in second byte

start:

 ; Display title
 bcall(_clrLCDFull)
 ld hl, 0
 ld (currow), hl
 ld hl, prgtitle + 1
 bcall(_puts)
 bcall(_newline)
 ld hl, author
 bcall(_puts)
 bcall(_newline)

 ; Get address of face
 ld hl, dice - 9
 ld de, 9
 ld a, (number)
 ld b, a
addloop:
 add hl, de
 djnz addloop
 bcall(_newline)

 ; Display face
 ld b, 3
rowloop:
 push bc
 ld b, 3
colloop:
 ld a, (hl)
 bcall(_putc)
 ld a, ' '
 bcall(_putc)
 inc hl
 djnz colloop
 bcall(_newline)
 pop bc
 djnz rowloop

 ; Display numbers
 bcall(_newline)
 ld a, (number)
 ld h, 0
 ld l, a
 bcall(_dispHL)
 ld a, '/'
 bcall(_putc)
 ld a, (outof)
 ld h, 0
 ld l, a
 bcall(_dispHL)

mainloop:
 ei
 halt ; Save power
 bcall(_GetCSC)

 ; Roll dice keys
 ld hl, roll
 push hl
 cp sk2
 jr z, roll2
 cp sk3
 jr z, roll3
 cp sk4
 jr z, roll4
 cp sk5
 jr z, roll5
 cp sk6
 jr z, roll6
 cp sk7
 jr z, roll7
 cp sk8
 jr z, roll8
 cp sk9
 jr z, roll9
 pop hl

 ; Yield
 cp skStat
 jr nz, mainloop
 call _tseForceYield
 jp start

roll2:
 ld b, 2
 ret
roll3:
 ld b, 3
 ret
roll4:
 ld b, 4
 ret
roll5:
 ld b, 5
 ret
roll6:
 ld b, 6
 ret
roll7:
 ld b, 7
 ret
roll8:
 ld b, 8
 ret
roll9:
 ld b, 9
 ret

roll:
 ld a, b
 ld (outof), a
 call ionRandom
 inc a
 ld (number), a
 jp start

dice:
xyz .equ 0E0h

.db ' ',' ',' ' ; 1
.db ' ',xyz,' '
.db ' ',' ',' '

.db ' ',' ',xyz ; 2
.db ' ',' ',' '
.db xyz,' ',' '

.db ' ',' ',xyz ; 3
.db ' ',xyz,' '
.db xyz,' ',' '

.db xyz,' ',xyz ; 4
.db ' ',' ',' '
.db xyz,' ',xyz

.db xyz,' ',xyz ; 5
.db ' ',xyz,' '
.db xyz,' ',xyz

.db xyz,' ',xyz ; 6
.db xyz,' ',xyz
.db xyz,' ',xyz

.db xyz,' ',xyz ; 7
.db xyz,xyz,xyz
.db xyz,' ',xyz

.db xyz,xyz,xyz ; 8
.db xyz,' ',xyz
.db xyz,xyz,xyz

.db xyz,xyz,xyz ; 9
.db xyz,xyz,xyz
.db xyz,xyz,xyz

author:
.db "By Robin Kay", 0

extdata:
number         .equ extdata
outof          .equ number+1
.end
